<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfIdentifierPoiResult ArrayType
 * @subpackage Arrays
 */
class ArrayOfIdentifierPoiResult extends AbstractStructArrayBase
{
    /**
     * The IdentifierPoiResult
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\IdentifierPoiResult[]
     */
    public $IdentifierPoiResult;
    /**
     * Constructor method for ArrayOfIdentifierPoiResult
     * @uses ArrayOfIdentifierPoiResult::setIdentifierPoiResult()
     * @param \StructType\IdentifierPoiResult[] $identifierPoiResult
     */
    public function __construct(array $identifierPoiResult = array())
    {
        $this
            ->setIdentifierPoiResult($identifierPoiResult);
    }
    /**
     * Get IdentifierPoiResult value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\IdentifierPoiResult[]|null
     */
    public function getIdentifierPoiResult()
    {
        return isset($this->IdentifierPoiResult) ? $this->IdentifierPoiResult : null;
    }
    /**
     * This method is responsible for validating the values passed to the setIdentifierPoiResult method
     * This method is willingly generated in order to preserve the one-line inline validation within the setIdentifierPoiResult method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateIdentifierPoiResultForArrayConstraintsFromSetIdentifierPoiResult(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfIdentifierPoiResultIdentifierPoiResultItem) {
            // validation for constraint: itemType
            if (!$arrayOfIdentifierPoiResultIdentifierPoiResultItem instanceof \StructType\IdentifierPoiResult) {
                $invalidValues[] = is_object($arrayOfIdentifierPoiResultIdentifierPoiResultItem) ? get_class($arrayOfIdentifierPoiResultIdentifierPoiResultItem) : sprintf('%s(%s)', gettype($arrayOfIdentifierPoiResultIdentifierPoiResultItem), var_export($arrayOfIdentifierPoiResultIdentifierPoiResultItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The IdentifierPoiResult property can only contain items of type \StructType\IdentifierPoiResult, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set IdentifierPoiResult value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\IdentifierPoiResult[] $identifierPoiResult
     * @return \ArrayType\ArrayOfIdentifierPoiResult
     */
    public function setIdentifierPoiResult(array $identifierPoiResult = array())
    {
        // validation for constraint: array
        if ('' !== ($identifierPoiResultArrayErrorMessage = self::validateIdentifierPoiResultForArrayConstraintsFromSetIdentifierPoiResult($identifierPoiResult))) {
            throw new \InvalidArgumentException($identifierPoiResultArrayErrorMessage, __LINE__);
        }
        if (is_null($identifierPoiResult) || (is_array($identifierPoiResult) && empty($identifierPoiResult))) {
            unset($this->IdentifierPoiResult);
        } else {
            $this->IdentifierPoiResult = $identifierPoiResult;
        }
        return $this;
    }
    /**
     * Add item to IdentifierPoiResult value
     * @throws \InvalidArgumentException
     * @param \StructType\IdentifierPoiResult $item
     * @return \ArrayType\ArrayOfIdentifierPoiResult
     */
    public function addToIdentifierPoiResult(\StructType\IdentifierPoiResult $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\IdentifierPoiResult) {
            throw new \InvalidArgumentException(sprintf('The IdentifierPoiResult property can only contain items of type \StructType\IdentifierPoiResult, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->IdentifierPoiResult[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\IdentifierPoiResult|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\IdentifierPoiResult|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\IdentifierPoiResult|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\IdentifierPoiResult|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\IdentifierPoiResult|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string IdentifierPoiResult
     */
    public function getAttributeName()
    {
        return 'IdentifierPoiResult';
    }
}
